/*
 * Auspice Services is copyright (c) 2000-2001 In Mean
 *     E-mail: auspice@auspice.org
 *
 * SirvNET Services is copyright (c) 1998-2000 Trevor Klingbeil.
 *     E-mail: <priority1@dal.net>
 * Originally based on EsperNet Services(c) by Andy Church.
 * This program is free but copyrighted software; see the file LICENSE for
 * details.
 */

#include "../inc/services.h"

Channel *chanlist = NULL;

static int smembers = 1;
static int schans = 0;
static int ssize = 0;

char *cmodeless;

static struct sjoin_list {
   char *nick;
} *slist = NULL;

void get_sjoin_list(char *list, int newchan);
static void extract_nicks();
static void add_suser(char *nick, char *channel);
/*************************************************************************/
/* Crappy little function to allocate sjoin memory
 * From SirvNET 1.4 */
void load_sjoin_mem()
{
       slist = smalloc(sizeof(*slist) * 1024);
       ssize = 1024;
}
/*************************************************************************/
void do_sjoin(char *source, int ac, char **av)
{
   Channel *chan;
#if (BAH_V >= 150) || defined(RAGEIRCD)
   int sf = 1;
#else if
   int sf = 0;
#endif
   char *schan = av[2-sf];
   char *s, *who, *tmpwho;
   char *mv[3];
   int args = 0, start = 4;
   register x;
   int newchan = 0, bogus=0;
   int inmean = 0;
   User *user;
   chan = findchan(av[2-sf]);
   if (!chan) {
      if (debug)
           log("Creating new channel %s via sjoin", av[2-sf]);

      chan = scalloc(sizeof(Channel), 1);
      chan->next = chanlist;
      if (chanlist)
          chanlist->prev = chan;
      chanlist = chan;
      strscpy(chan->name, av[2-sf], sizeof(chan->name));
      chan->creation_time = time(NULL);
      chan->ngames = 1;
      chan->wgames = 1;
      newchan = 1;
   }


#if BAH_V >= 150
   if (!strchr(source, '.')) {
        if (!(user = finduser(source))) {
             bogus=0; smembers=0;
             goto bogus_join;
        }
        chan_adduser(user, schan);
        add_suser(source, chan->name);
        return;
   }
#endif

#ifdef RAGEIRCD
	sf = 0;
#endif

   if (stricmp(av[3-sf], "0") == 0)
      goto skipmodes;

   s = av[3-sf];
   strscpy(chan->modes, changemode(s, chan->modes), sizeof(chan->modes));
   while (*s) {
        switch(*s++) {
            case 'l':
                if (chan->limit > 0)
                   chan->limit = 0;
                chan->limit = atoi(av[4-sf]);
		inmean++;
                break;
            case 'k':
                if (chan->key) {
                   free(chan->key);
                   chan->key = NULL;
                }
		inmean++;
                chan->key = sstrdup(av[4-sf+inmean]);
                args++;
                break;
        }
   }

   strscpy(chan->modes, changemode("-lk", chan->modes), sizeof(chan->modes));
   check_modes(chan->name);

   if (stricmp(av[3-sf], "+") != 0) {

       if (chan->key && (chan->limit > 0))
           start += 2;
       else if ((!chan->key && (chan->limit > 0)) ||
                 (chan->key && (chan->limit == 0)))
           start++;
   }

skipmodes:

   mv[0] = sstrdup(chan->name);
   get_sjoin_list(av[start-sf], newchan);

   for (x = 0; x < smembers; x++) {

         if (strchr(slist[x].nick, '@') && strchr(slist[x].nick, '+')) {
       	     if (!(user = finduser(strtok(slist[x].nick, "@+")))) {
                bogus++; continue;
             }
             mv[2] = sstrdup(user->nick);
             add_suser(mv[2], mv[0]);
             if (check_valid_op(user, mv[0], 1)) {
                mv[1] = "+o";
                do_cmode(source, 3, mv);
             } else {
                 send_cmd(s_ChanServ, "MODE %s -o %s", mv[0], mv[2]);
                 notice(s_ChanServ, mv[2], toknmsg[25], chan->name, s_ChanServ);
             }

             mv[1] = "+v";
             do_cmode(source, 3, mv);

	 } else if (strchr(slist[x].nick, '@')) {
             if (!(user = finduser(strtok(slist[x].nick, "@")))) {
                bogus++; continue;
             }
             mv[2] = sstrdup(user->nick);
             add_suser(mv[2], mv[0]);
             if (check_valid_op(user, mv[0], 1)) {
	         mv[1] = sstrdup("+o");
       	         do_cmode(source, 3, mv);
             } else {
                 send_cmd(s_ChanServ, "MODE %s -o %s", mv[0], mv[2]);
                 notice(s_ChanServ, mv[2], toknmsg[25], chan->name, s_ChanServ);
             }
#ifdef DEFHALFOP
	 } else if (strchr(slist[x].nick, '%')) {
             if (!(user = finduser(strtok(slist[x].nick, "%")))) {
                bogus++; continue;
             }
             mv[2] = sstrdup(user->nick);
             mv[1] = sstrdup("+h");
             add_suser(mv[2], mv[0]);
             do_cmode(source, 3, mv);
#endif
#ifdef DEFPROTECT
	 } else if (strchr(slist[x].nick, '^')) {
             if (!(user = finduser(strtok(slist[x].nick, "^")))) {
                bogus++; continue;
             }
             mv[2] = sstrdup(user->nick);
             mv[1] = sstrdup("+a");
             add_suser(mv[2], mv[0]);
             do_cmode(source, 3, mv);
#endif
#ifdef UNREAL
	} else if (strchr(slist[x].nick, '*')) {
             if (!(user = finduser(strtok(slist[x].nick, "*")))) {
                bogus++; continue;
             }
             mv[2] = sstrdup(user->nick);
             mv[1] = sstrdup("+q");
             add_suser(mv[2], mv[0]);
             do_cmode(source, 3, mv);

#endif

	 } else if (strchr(slist[x].nick, '+')) {
             if (!(user = finduser(strtok(slist[x].nick, "+")))) {
                bogus++; continue;
             }
             mv[2] = sstrdup(user->nick);
             mv[1] = sstrdup("+v");
             add_suser(mv[2], mv[0]);
             do_cmode(source, 3, mv);

         } else {
             if (!(user = finduser(slist[x].nick))) {
                bogus++; continue;
             }
             mv[2] = sstrdup(slist[x].nick);
             add_suser(mv[2], mv[0]);
	}

         if ((bogus == smembers) && newchan)
             goto bogus_join;

      user = finduser(mv[2]);

      if (!user)
	return;

      if (!is_chanop(mv[2], schan))
           chan_adduser(user, schan);

      free(slist[x].nick); slist[x].nick = sstrdup(mv[2]);
      free(mv[2]);

      check_welcome(user, chan->name);

/* do_join removed - as I said, I got around to improving it :P */

      if (newchan && (x < 1)) { /* x to prevent repeated topics */
            restore_topic(chan->name);
#if defined(BAHAMUT) || defined(RAGEIRCD)
	    if (!chan->havebot)
		    botjoin(chan->name);
	    do_cs_join(chan->name);
#endif

      }

      mv[1] = NULL;
   }
   free(mv[0]);

bogus_join:

   if ((bogus == smembers) && newchan) {
       if (chan->next)
            chan->next->prev = chan->prev;
       if (chan->prev)
            chan->prev->next = chan->next;
       else
            chanlist = chan->next;
       free(chan); free(mv[2]);
   }

   for (x = 0; x < smembers; x++) {
       user = finduser(slist[x].nick);
       if (user) {
           check_kick(user, chan->name);
		if (!rec_services_root(user->nick)) 
	           check_invite(user, chan->name);
       }
           free(slist[x].nick);
   }

}

/*************************************************************************/
void get_sjoin_list(char *list, int newchan)
{
    char *tmp = strtok(list, " ");
    smembers = 1;

    slist[0].nick = sstrdup(tmp);
    if (newchan)
      ++schans;

    extract_nicks();
}
/*************************************************************************/

void extract_nicks()
{
   char *tmp;
   int i = 1;

   while ((tmp = strtok(NULL, " ")) != NULL)
   {
       slist[i++].nick = sstrdup(tmp);

   }
   smembers = i;
  
}

/*************************************************************************/

/* Return statistics.  Pointers are assumed to be valid. */

void get_channel_stats(long *nrec, long *memuse)
{
    long count = 0, mem = 0;
    Channel *chan;
    struct c_userlist *cu;
    int i;

    for (chan = chanlist; chan; chan = chan->next) {
	count++;
	mem += sizeof(*chan);
	if (chan->topic)
	    mem += strlen(chan->topic)+1;
	if (chan->key)
	    mem += strlen(chan->key)+1;
	if (chan->flood)
	    mem += strlen(chan->flood)+1;
	if (chan->link)
	    mem += strlen(chan->link)+1;
	if (chan->wgame)
	    mem += strlen(chan->wgame)+1;
	mem += sizeof(char *) * chan->bansize;
	for (i = 0; i < chan->bancount; i++) {
	    if (chan->bans[i])
		mem += strlen(chan->bans[i])+1;
	}
	for (cu = chan->users; cu; cu = cu->next) 
	 	mem += sizeof(*cu);
	for (cu = chan->chanops; cu; cu = cu->next)
	    mem += sizeof(*cu);
#ifdef DEFHALFOP
	for (cu = chan->halfop; cu; cu = cu->next)
	    mem += sizeof(*cu);
#endif
	for (cu = chan->voices; cu; cu = cu->next)
	    mem += sizeof(*cu);
#ifdef DEFPROTECT
	for (cu = chan->prots; cu; cu = cu->next)
	    mem += sizeof(*cu);
#endif
#ifdef UNREAL
	for (cu = chan->cfounder; cu; cu = cu->next)
	    mem += sizeof(*cu);
#endif
    }
    *nrec = count;
    *memuse = mem;
}

/*************************************************************************/

/* Return the Channel structure corresponding to the named channel, or NULL
 * if the channel was not found. */

Channel *findchan(const char *chan)
{
    Channel *c = chanlist;

    while (c) {
	if (stricmp(c->name, chan) == 0)
	    return c;
	c = c->next;
    }
    return NULL;
}

/*************************************************************************/

/* Add/remove a user to/from a channel, creating or deleting the channel as
 * necessary. */

void chan_adduser(User *user, const char *chan)
{
    Channel *c = findchan(chan);
    int newchan = !c;
    struct c_userlist *u;

#ifndef BAHSJOIN
    if (newchan) {
	if (debug)
	    log("debug: Creating channel %s", chan);
	/* Allocate pre-cleared memory */

	c = scalloc(sizeof(Channel), 1);
	c->next = chanlist;
	if (chanlist)
	    chanlist->prev = c;
	chanlist = c;
	strscpy(c->name, chan, sizeof(c->name));
	c->creation_time = time(NULL);
	/* This will restore locked modes and saved topic */
        check_invite(user, chan);
	check_modes(chan);
        restore_topic(chan);
	if (!c->havebot)
		botjoin(c->name);
        do_cs_join(chan);
    }
#endif

    if (check_should_voice(user, chan)) {
	u = smalloc(sizeof(struct c_userlist));
	u->next = c->voices;
	u->prev = NULL;
	if (c->voices)
	    c->voices->prev = u;
	c->voices = u;
	u->user = user;
    }

    if (!check_opguard(user, chan, newchan) || newchan)
     	;

    else if (check_should_op(user, chan)) {
	u = smalloc(sizeof(struct c_userlist));
	u->next = c->chanops;
	u->prev = NULL;
	if (c->chanops)
	    c->chanops->prev = u;
	c->chanops = u;
	u->user = user;
    }   

#ifdef DEFHALFOP
    if (check_should_halfop(user, chan)) {
	u = smalloc(sizeof(struct c_userlist));
	u->next = c->halfop;
	u->prev = NULL;
	if (c->halfop)
	    c->halfop->prev = u;
	c->halfop = u;
	u->user = user;
    }
#endif

#ifdef DEFPROTECT
    if (check_should_protect(user, chan)) {
        u = smalloc(sizeof(struct c_userlist));
        u->next = c->prots;
        u->prev = NULL;
        if (c->prots)
            c->prots->prev = u;
        c->prots = u;
        u->user = user;
    }
#endif

#ifdef UNREAL
    if (check_should_founderize(user, chan)) {
        u = smalloc(sizeof(struct c_userlist));
        u->next = c->cfounder;
        u->prev = NULL;
        if (c->cfounder)
            c->cfounder->prev = u;
        c->cfounder = u;
        u->user = user;
    }
#endif


#ifndef BAHSJOIN
    u = smalloc(sizeof(struct c_userlist));
    u->next = c->users;
    u->prev = NULL;
    if (c->users)
	c->users->prev = u;
    c->users = u;
    u->user = user;
    c->usercount++;
#endif

}

void chan_deluser(User *user, Channel *c)
{
    struct c_userlist *u;
    struct c_userlist *u2;
    int i;

    if (!user || !c)
       return;

    u2 = c->users;
    if (!u2)
      return;


    for (u = c->users; u && u->user != user; u = u->next)
        ;
    if (!u)
	return;

    if (u->next)
	u->next->prev = u->prev;
    if (u->prev)
	u->prev->next = u->next;
    else
	c->users = u->next;
    free(u);


    for (u = c->chanops; u && u->user != user; u = u->next)
    ;
    if (u) {
	if (u->next)
	    u->next->prev = u->prev;
	if (u->prev)
	    u->prev->next = u->next;
	else
	    c->chanops = u->next;
	free(u);
    }    

#ifdef DEFHALFOP
    for (u = c->halfop; u && u->user != user; u = u->next)
	;
    if (u) {
	if (u->next)
	    u->next->prev = u->prev;
	if (u->prev)
	    u->prev->next = u->next;
	else
	    c->halfop = u->next;
	free(u);
    }

#endif

    for (u = c->voices; u && u->user != user; u = u->next)
	;
    if (u) {
	if (u->next)
	    u->next->prev = u->prev;
	if (u->prev)
	    u->prev->next = u->next;
	else
	    c->voices = u->next;
	free(u);
    }

#ifdef DEFPROTECT
    for (u = c->prots; u && u->user != user; u = u->next)
	;
    if (u) {
	if (u->next)
	    u->next->prev = u->prev;
	if (u->prev)
	    u->prev->next = u->next;
	else
	    c->prots = u->next;
	free(u);
    }
#endif
#ifdef UNREAL
    for (u = c->cfounder; u && u->user != user; u = u->next)
	;
    if (u) {
	if (u->next)
	    u->next->prev = u->prev;
	if (u->prev)
	    u->prev->next = u->next;
	else
	    c->cfounder = u->next;
	free(u);
    }
#endif
    if (c->usercount)
	    c->usercount--;

    if (!c->users) {
        --schans;
	do_cs_part(c->name);
	botpart(c->name);
	if (debug)
	    log("debug: Deleting channel %s", c->name);

	if (c->topic)
	    free(c->topic);
	if (c->key)
	    free(c->key);
	if (c->link)
	    free(c->link);
	if (c->flood)
	    free(c->flood);
	if (c->wgame)
	    free(c->wgame);
	if (c->bancount) {
	    int i;
	    for (i = 0; i < c->bancount; ++i)
		free(c->bans[i]);
	}
	if (c->bansize)
	    free(c->bans);
	if (c->chanops || c->voices
#ifdef DEFHALFOP
	 || c->halfop
#endif
#ifdef DEFPROTECT
	 || c->prots
#endif
#ifdef UNREAL
	 || c->cfounder
#endif
	    )
	    log("channel: Memory leak freeing %s: %s%s%s%s are non-NULL!", 
		        c->name,
                        c->chanops ? "c->chanops, " : "",
                        c->voices ? "c->voices, " : "",
#ifdef DEFHALFOP
                        c->halfop ? "c->halfop," : "",
#else
			"",
#endif
#ifdef DEFPROTECT
                        c->prots ? "c->prots," : "",
#else
			"",
#endif
#ifdef UNREAL
                        c->cfounder ? "c->cfounder," : ""
#else
			""
#endif
			);
	if (c->next)
	    c->next->prev = c->prev;
	if (c->prev)
	    c->prev->next = c->next;
	else
	    chanlist = c->next;
	free(c);
    }
}

/*************************************************************************/

/* Handle a channel MODE command. */

void do_cmode(const char *source, int ac, char **av)
{
    Channel *chan;
    struct c_userlist *u;
    User *user;
    char *s, *nick;
    int add = 1;		/* 1 if adding modes, 0 if deleting */
    int serverop = 0;
    char *modestr = av[1];

    chan = findchan(av[0]);
    if (!chan) {
	log("channel: MODE %s for nonexistent channel %s",
                                     merge_args(ac-1, av+1), av[0]);
	return;
    }

    s = modestr;
    ac -= 2;
    av += 2;
   
    while (*s) {

	switch (*s++) {

	case '+':
	    add = 1; break;

	case '-':
	    add = 0; break;

	case 'k':
	    if (chan->key) {
		free(chan->key);
		chan->key = NULL;
	    }
	    if (add)
		chan->key = sstrdup(*av++);
	    break;

	case 'l':
	    if (add) {
		chan->limit = atoi(*av++);
	    } else {
		chan->limit = 0;
	    }
	    break;

#ifdef UNREAL
        case 'L':
            if (--ac < 0) {
                log("channel: MODE %s %s: missing parameter for %cL",
                                        chan->name, modestr, add ? '+': '-');
                break;
            }
            if (chan->link) {
                free(chan->link);
                chan->link = NULL;
            }
            if (add && *av)
                chan->link = sstrdup(*av++);
            break;

        case 'f':
            if (--ac < 0) {
                log("channel: MODE %s %s: missing parameter for %cf",
                                        chan->name, modestr, add ? '+': '-');
                break;
            }
            if (chan->flood) {
                free(chan->flood);
                chan->flood = NULL;
            }
            if (add && *av)
                chan->flood = sstrdup(*av++);
		break;
#endif

	case 'b':
	    if (--ac < 0) {
		log("channel: MODE %s %s: missing parameter for %cb",
					chan->name, modestr, add ? '+' : '-');
		break;
	    }
	    if (add) {
		if (chan->bancount >= chan->bansize) {
		    chan->bansize += 8;
		    chan->bans = srealloc(chan->bans,
					sizeof(char *) * chan->bansize);
		}
		chan->bans[chan->bancount++] = sstrdup(*av++);
	    } else {
		char **s = chan->bans;
		int i = 0;
		while (i < chan->bancount && strcmp(*s, *av) != 0) {
		    ++i; ++s;
		}
		if (i < chan->bancount) {
		    --chan->bancount;
		    if (i < chan->bancount)
			bcopy(s+1, s, sizeof(char *) * (chan->bancount-i));
		}
		++av;
	    }
	    break;

	case 'o':
	    if (--ac < 0) {
		log("channel: MODE %s %s: missing parameter for %co",
					chan->name, modestr, add ? '+' : '-');
		break;
	    }
	    nick = *av++;
	    if (add) {
		for (u = chan->chanops; u && stricmp(u->user->nick, nick) != 0;
								u = u->next)
		    ;
		if (u)
		    break;
		user = finduser(nick);

		if (!user) {
		    log("channel: MODE %s +o for nonexistent user %s",
							chan->name, nick);
		    break;
		}
		if (debug)
		    log("debug: Setting +o on %s for %s", chan->name, nick);

		u = smalloc(sizeof(*u));
		u->next = chan->chanops;
		u->prev = NULL;
		if (chan->chanops)
		    chan->chanops->prev = u;
		chan->chanops = u;
		u->user = user;

	    } else {
		for (u = chan->chanops; u && stricmp(u->user->nick, nick);
								u = u->next)
		    ;
		if (!u)
		    break;
		if (u->next)
		    u->next->prev = u->prev;
		if (u->prev)
		    u->prev->next = u->next;
		else
		    chan->chanops = u->next;
		free(u);
	    }
	    break;
#ifdef DEFHALFOP
	case 'h':
	    if (--ac < 0) {
		log("channel: MODE %s %s: missing parameter for %ch",
					chan->name, modestr, add ? '+' : '-');
		break;
	    }
	    nick = *av++;
	    if (add) {
		for (u = chan->halfop; u && stricmp(u->user->nick, nick);
		u = u->next)
		    ;
		if (u)
		    break;
		user = finduser(nick);
		if (!user) {
		    log("channel: MODE %s +h for nonexistent user %s",
							chan->name, nick);
		    break;
		}
		if (debug)
		    log("debug: Setting +h on %s for %s", chan->name, nick);
		u = smalloc(sizeof(*u));
		u->next = chan->halfop;
		u->prev = NULL;
		if (chan->halfop)
		    chan->halfop->prev = u;
		chan->halfop = u;
		u->user = user;
	    } else {
		for (u = chan->halfop; u && stricmp(u->user->nick, nick);
								u = u->next)
		    ;
		if (!u)
		    break;
		if (u->next)
		    u->next->prev = u->prev;
		if (u->prev)
		    u->prev->next = u->next;
		else
		    chan->halfop = u->next;
		free(u);
	    }
	    break;
#endif
	case 'v':
	    if (--ac < 0) {
		log("channel: MODE %s %s: missing parameter for %cv",
					chan->name, modestr, add ? '+' : '-');
		break;
	    }
	    nick = *av++;
	    if (add) {
		for (u = chan->voices; u && stricmp(u->user->nick, nick);
								u = u->next)
		    ;
		if (u)
		    break;
		user = finduser(nick);
		if (!user) {
		    log("channel: MODE %s +v for nonexistent user %s",
							chan->name, nick);
		    break;
		}
		if (debug)
		    log("debug: Setting +v on %s for %s", chan->name, nick);
		u = smalloc(sizeof(*u));
		u->next = chan->voices;
		u->prev = NULL;
		if (chan->voices)
		    chan->voices->prev = u;
		chan->voices = u;
		u->user = user;
	    } else {
		for (u = chan->voices; u && stricmp(u->user->nick, nick);
								u = u->next)
		    ;
		if (!u)
		    break;
		if (u->next)
		    u->next->prev = u->prev;
		if (u->prev)
		    u->prev->next = u->next;
		else
		    chan->voices = u->next;
		free(u);
	    }
	    break;
#ifdef UNREAL
	case 'q':
	    if (--ac < 0) {
		log("channel: MODE %s %s: missing parameter for %cq",
					chan->name, modestr, add ? '+' : '-');
		break;
	    }
	    nick = *av++;
	    if (add) {
		for (u = chan->cfounder; u && stricmp(u->user->nick, nick);
								u = u->next)
		    ;
		if (u)
		    break;
		user = finduser(nick);
		if (!user) {
		    log("channel: MODE %s +q for nonexistent user %s",
							chan->name, nick);
		    break;
		}
		if (debug)
		    log("debug: Setting +q on %s for %s", chan->name, nick);

                if (!check_valid_op(user, chan->name, !!strchr(source, '.'))) {
                       send_cmd(s_ChanServ, "MODE %s -q %s", chan->name, nick);
                       break;
                } else {

		u = smalloc(sizeof(*u));
		u->next = chan->cfounder;
		u->prev = NULL;
		if (chan->cfounder)
		    chan->cfounder->prev = u;
		chan->cfounder = u;
		u->user = user;
		}
	    } else {
		for (u = chan->cfounder; u && stricmp(u->user->nick,nick);
								u = u->next)
		    ;
		if (!u)
		    break;
		if (u->next)
		    u->next->prev = u->prev;
		if (u->prev)
		    u->prev->next = u->next;
		else
		    chan->cfounder = u->next;
		free(u);
	    }
	    break;
#endif
#ifdef DEFPROTECT
#ifdef UNREAL
	case 'a':
#endif
#if defined(LIQUID) || defined(RAGEIRCD)
	case 'u':
#endif

	    if (--ac < 0) {
		log("channel: MODE %s %s: missing parameter for %ca",
					chan->name, modestr, add ? '+': '-');
		break;
	    }
	    nick = *av++;
	    if (add) {
		for (u = chan->prots; u && stricmp(u->user->nick, nick);
								u = u->next)
		    ;
		if (u)
		    break;
		user = finduser(nick);
		if (!user) {
		    log("channel: MODE %s +a for nonexistent user %s",
							chan->name, nick);
		    break;
		}
		if (debug)
		    log("debug: Setting +a on %s for %s", chan->name, nick);

                if (!check_valid_op(user, chan->name, !!strchr(source, '.'))) {
#ifdef UNREAL
                       send_cmd(s_ChanServ, "MODE %s -a %s", chan->name, nick);
#endif
#if defined(LIQUID) || defined(RAGEIRCD)
                       send_cmd(s_ChanServ, "MODE %s -u %s", chan->name, nick);
#endif
                       break;
                } else {

		u = smalloc(sizeof(*u));
		u->next = chan->prots;
		u->prev = NULL;
		if (chan->prots)
		    chan->prots->prev = u;
		chan->prots = u;
		u->user = user;
		}
	    } else {
		for (u = chan->prots; u && stricmp(u->user->nick, nick);
								u = u->next)
		    ;
		if (!u)
		    break;
		if (u->next)
		    u->next->prev = u->prev;
		if (u->prev)
		    u->prev->next = u->next;
		else
		    chan->prots = u->next;
		free(u);
	    }
	    break;
#endif
	} /* switch */

    } /* while (*s) */

    strscpy(chan->modes, changemode(modestr, chan->modes), sizeof(chan->modes));
    strscpy(chan->modes, changemode(cmodeless, chan->modes), sizeof(chan->modes));

    if (!chan->key && hasmode("k", chan->modes))
        strscpy(chan->modes, changemode("-k", chan->modes),sizeof(chan->modes));
    if (!chan->limit && hasmode("l", chan->modes))
        strscpy(chan->modes, changemode("-l", chan->modes),sizeof(chan->modes));

#ifdef UNREAL
    if (!chan->link && hasmode("L", chan->modes))
        strscpy(chan->modes, changemode("-L",chan->modes),sizeof(chan->modes));
    if (!chan->flood && hasmode("f", chan->modes))
        strscpy(chan->modes, changemode("-f",chan->modes),sizeof(chan->modes));
#endif
    /* Check modes against ChanServ mode lock */
    if(!is_services_nick(source))
         check_modes(chan->name);
}

/*************************************************************************/

/* Handle a TOPIC command. */

void do_topic(const char *source, int ac, char **av)
{
    Channel *c = findchan(av[0]);

    if (!c)
	return;
    
    if (!strchr(source, '.')) {
        if (check_topiclock(source, av[0]))
           return;
    } else
           return;

    strscpy(c->topic_setter, av[1], sizeof(c->topic_setter));
    c->topic_time = atol(av[2]);
    if (c->topic) {
	free(c->topic);
	c->topic = NULL;
    }
    if (ac > 3 && *av[3])
	c->topic = sstrdup(av[3]);

    record_topic(av[0]);
}

/*************************************************************************/

/* Does the given channel have only one user? */

/* Note:  This routine is not currently used, but is kept around in case it
 * might be handy someday. */

//#if 0

int only_one_user(const char *chan)
{
    Channel *c;

    for (c = chanlist; c; c = c->next) {
	if (stricmp(c->name, chan) == 0)
	    return (c->users && !c->users->next) ? 1 : 0;
    }
    return 0;
}

//#endif

int isin_chan(char *nick, const char *chan)
{
    Channel *c;
    struct c_userlist *cu;

    for (c = chanlist; c; c = c->next) {
        if (stricmp(c->name, chan) == 0) {
	    for (cu = c->users; cu; cu = c->users->next) {
		if (stricmp(cu->user->nick, nick) == 0)
		    return 1;
	    }
	    return 0;
	}
    }
    return 0;
}
/*************************************************************************/
int channel_form()
{
    Channel *c;
    int i = 0;
    for (c = chanlist; c; c = c->next)
	i++;
    return i;
}
/*************************************************************************/
void html_chan()
{
    Channel *c;
    struct c_userlist *cu;
    int i, j;
    FILE *fp;
    i = 1;
    fp = fopen("channel.html", "w");
    if (fp) {
    for (c = chanlist; c; c = c->next) {
	    fprintf (fp, "<p>%s (%d)<br>", c->name, c->usercount);
	    fprintf (fp, "<b>Topic:</b> <i>%s</i> (%s)</p>\n", c->topic, c->topic_setter);
    }
    }
    fclose (fp);

}


/*************************************************************************/
void change_cmode (const char *who, const char *chan, const char *mode, const char *pram)
{
    char *av[3];
    av[0] = sstrdup (chan);
    av[1] = sstrdup (mode);
    av[2] = sstrdup (pram);
    send_cmd (who, "MODE %s %s %s", chan, mode, pram);
    do_cmode (who, 3, av);
    free (av[2]);
    free (av[1]);
    free (av[0]);
}
/***************************************************/
static void add_suser(char *nick, char *channel)
{
   Channel *chan = findchan(channel);
   struct c_userlist *u;
   struct u_chanlist *c;
   User *user = finduser(nick);

      u = smalloc(sizeof(struct c_userlist));
      u->next = chan->users;
      u->prev = NULL;
      if (chan->users)
         chan->users->prev = u;
      chan->users = u;
      u->user = user;

      c = smalloc(sizeof(*c));
      c->next = user->chans;
      c->prev = NULL;
      if (user->chans)
          user->chans->prev = c;
      user->chans = c;
      c->chan = findchan(chan->name);
}
/***************************************************************/
char *filter_modes (char *chan, char *on, char *off)
{
    Channel *c = findchan (chan);
    ChannelInfo *ci = cs_findchan (chan);
    char *current = c->modes;
    char new_on[64];
    char new_off[64];
    char filtered[64];


    if (!c || !ci)
        return;

    *filtered = *new_on = *new_off = 0;

    if (strchr (on, 'c') && !strchr (current, 'c') && !strchr (off, 'c'))
        strcat (new_on, "c");
    if (strchr (on, 'i') && !strchr (current, 'i') && !strchr (off, 'i'))
        strcat (new_on, "c");
    if (strchr (on, 'i') && !strchr (current, 'i') && !strchr (off, 'i'))
        strcat (new_on, "i");
    if (strchr (on, 'k') && !strchr (current, 'k') && !strchr (off, 'k'))
        strcat (new_on, "k");
    if (strchr (on, 'l') && !strchr (current, 'l') && !strchr (off, 'l'))
        strcat (new_on, "l");
    if (strchr (on, 'm') && !strchr (current, 'm') && !strchr (off, 'm'))
        strcat (new_on, "m");
    if (strchr (on, 'n') && !strchr (current, 'n') && !strchr (off, 'n'))
        strcat (new_on, "n");
    if (strchr (on, 'p') && !strchr (current, 'p') && !strchr (off, 'p'))
        strcat (new_on, "p");
    if (strchr (on, 'r') && !strchr (current, 'r') && !strchr (off, 'r'))
        strcat (new_on, "r");
    if (strchr (on, 'R') && !strchr (current, 'R') && !strchr (off, 'R'))
        strcat (new_on, "R");
    if (strchr (on, 's') && !strchr (current, 's') && !strchr (off, 's'))
        strcat (new_on, "s");
    if (strchr (on, 't') && !strchr (current, 't') && !strchr (off, 't'))
        strcat (new_on, "t");
    if (strchr (off, 'c') && strchr (current, 'c') && !strchr (on, 'c'))
        strcat (new_off, "c");
    if (strchr (off, 'i') && strchr (current, 'i') && !strchr (on, 'i'))
        strcat (new_off, "i");
    if (strchr (off, 'k') && strchr (current, 'k') && !strchr (on, 'k'))
        strcat (new_off, "k");
    if (strchr (off, 'l') && strchr (current, 'l') && !strchr (on, 'l'))
        strcat (new_off, "l");
    if (strchr (off, 'm') && strchr (current, 'm') && !strchr (on, 'm'))
        strcat (new_off, "m");
    if (strchr (off, 'n') && strchr (current, 'n') && !strchr (on, 'n'))
        strcat (new_off, "n");
    if (strchr (off, 'p') && strchr (current, 'p') && !strchr (on, 'p'))
        strcat (new_off, "p");
    if (strchr (off, 'r') && strchr (current, 'r') && !strchr (on, 'r'))
        strcat (new_off, "r");
    if (strchr (off, 'R') && strchr (current, 'R') && !strchr (on, 'R'))
        strcat (new_off, "R");
    if (strchr (off, 's') && strchr (current, 's') && !strchr (on, 's'))
        strcat (new_off, "s");
    if (strchr (off, 't') && strchr (current, 't') && !strchr (on, 't'))
        strcat (new_off, "t");

    if (strlen (new_on))
    {
        strcat (filtered, "+");
        strcat (filtered, new_on);
    }
    if (strlen (new_off))
    {
        strcat (filtered, "-");
        strcat (filtered, new_off);
    }
    if (ci->mlock_limit && c->limit != ci->mlock_limit)
        if (strlen (new_on))
            if (strchr (new_on, 'l'))
            {
                strcat (filtered, " ");
                strcat (filtered, myitoa(ci->mlock_limit));
            }
    if (ci->mlock_key && (!c->key || !strcmp (c->key, ci->mlock_key)))
        if (strlen (new_on))
            if (strchr (new_on, 'k'))
            {
                strcat (filtered, " ");
                strcat (filtered, ci->mlock_key);
            }
    if (strlen (new_off))
        if (strchr (new_off, 'k'))
        {
            strcat (filtered, " ");
            strcat (filtered, c->key);
        }
    if (strlen (filtered))
        change_cmode (s_ChanServ, c->name, filtered, "");
}

