/* MemoServ special help texts.
 *
 * SirvNET Services is copyright (c) 1998-2000 Trevor Klingbeil.
 *     E-mail: <priority1@dal.net>
 * Originally based on EsperNet Services(c) by Andy Church.
 * This program is free but copyrighted software; see the file LICENSE for
 * details.
 */


/************************************************************************/

static const char *cs_servadmin_help[] = {
"MemoServ Commands:",
"    INFO       View information on a nick's memo list",
"The following commands are avalible to Services Admins:",
"    OSEND      Global memo system for network opers",
"    LIMIT      Set the max memos for a nick",
"The following commands are avalible to Services Roots:",
"    GLOBAL     Send a global memo to all registered nicks",
"The following commands are avalible to Services Master:",
"    NEWSRESET  Reset the news to Original Message for new add.",
"    NEWSINSERT Insert the Topic and message into the News.",
"    NEWSREHASH Lock the News and declaire as new News.",
NULL
};

/************************************************************************/

static const char *global_help[] = {
"Syntax: \2GLOBAL \37message\37\2",
"",
"Services roots may send global memos.",
"This command should never be used.",
NULL
};

/************************************************************************/

static const char *limit_help[] = {
"Syntax: \2SET LIMIT \37user\37 \37limit\37\2",
"",
"Sets the maximum number of memos a user is allowed to",
"have.  Setting the limit to 0 disables this and allows the",
"user to receive and keep as many memos as they want.",
NULL
};

/************************************************************************/
static const char *osend_help[] = {
"Syntax: \2OSEND [\37SA\37|\37SRA\37] <\37message\37>\2",
"",
"OSEND allows network Operators to send global memos to",
"one another. Similar to WALLOPS or GLOBOPS except its",
"with memos. SA will memo all Services Admins and Roots,",
"SRA will only send the memo to Services Roots.",
"",
"Example: OSEND SRA Congratulations to John_1 for becomming an SA!",
NULL
};
/************************************************/
static const char *ms_help_index[] = {
"\2" ms "\2 is a utility allowing IRC users to send short",
"messages to other IRC users, whether they are online at",
"the time or not.  Both sender and recipient must have",
"their nicknames registered with \2" ns "\2 in order to",
"send a memo.",
" ",
"" ms "'s commands include:",
" ",
"    SEND     Send a memo to a nick/channel",
"    CSEND    Send a channel memo to higher access levels.",
"    LIST     List all of your memos",
"    READ     Read a memo",
"    DEL      Set Delete flag for a memo (or all memos)",
"    UNDEL    Remove the delete flag for a memo (or all memos)",
"    UNSEND   Retrieve a memo sent to a user",
"    PURGE    Erase all marked memos as deleted",
"    FORWARD  Have memos forwarded to another registered nick",
"    NEWS     Reading Network News",
"    SET      Set options related to memos",
" ",
"Type \2/msg " ms " HELP \37command\37\2 for help on any of the",
"above commands.",
" ",
NULL
};
/**************************************************/
static const char *ms_help_nohelp[] = {
"No help for this command.",
NULL
};
/***************************************************/
static const char *ms_help_csend[] = {
"Syntax: \2CSEND #<chan> [\37HOP\37|\37AOP\37|\37SOP\37|\37CF\37] <message>\2"
" ",
"This command will send a channel memo to only the",
"higher channel access users.",
"Selections:  HOP = Will send to all  HOP/AOP/SOP/CF",
"             AOP = Will send to all  AOP/SOP/CF",
"             SOP = Will only send to SOP and Co-Founders",
"              CF = Will only send to Channel Founders",
"* Note:  The Founder receives memos from any selection.",
"         Also, selecting ALL or VOP will just send",
"         a general channel memo.",
" ",
"EX: /MSG " ms " CSEND #mychan SOP hello all",
" ",
"The Above example will send \"hello all\" to the",
"channel's Super-Ops, Co-Founders and Founder.",
" ",
NULL
};
/******************************************************************/
static const char *ms_help_del[] = {
"Syntax: \2DEL {\37num\37|\37ALL\37}",
" ",
"If a number \37num\37 is given, the specififed memo will",
"be \37MARKED\37 as deleted. Memos that are marked are",
"not actually erased until you use \37PURGE\37 or when",
"you log offline. Memos that have been deleted can",
"be shown with a \"D\" to the left of the memo number",
"in \2" ms " LIST\2. If \2ALL\2 is given, all of your",
"memos will be marked as deleted.",
" ",
NULL
};
/***************************************************/
static const char *ms_help_forward[] = {
"Syntax: \2FORWARD \37nick\37 \2",
" ",
"Forwards all memos comming to your current",
"nick to the one you have specified. The",
"specified nick to have memos being forwarded",
"to must be registered with \2" ns "\2.",
"If no nick is given, forwarding will be",
"disabled. Channel memo's will automatically",
"be forwarded as well.",
"Note: When emailing and forwarding memo",
"      options have been enabled, the",
"      target nick's email address will be",
"      used, not the forwarded target.",
" ",
NULL
};
/*********************************************************/
static const char *ms_help_list[] = {
"Syntax: \2LIST [NEW]\2",
" ",
"Lists any memos you currently have.  With NEW, lists only",
"new (unread) memos.  Unread memos are marked with a \"*\"",
"to the left of the memo number. Marked memos as deleted",
"are displayed with a \"D\" to the left of the memo number.",
" ",
NULL
};
/**********************************************************/
static const char *ms_help_news[] = {
"Syntax: \2NEWS\2",
" ",
"Show the current Network news.",
" ",
NULL
};
/**********************************************************/
static const char *ms_help_read[] = {
"Syntax: \2READ {\37num\37|\37LAST\37}\2",
" ",
"Sends you the text of memo number \37num\37, or of the last",
"(i.e. most recently received) memo if LAST is given",
"instead of a number.",
" ",
NULL
};
/***********************************************************/
static const char *ms_help_send[] = {
"Syntax: \2SEND {\37nick\37|\37#chan\37}  \37memo-text\37\2",
" ",
"Sends the named \37nick\37 or \37chan\37 a memo containing \37memo-text\37.",
"The recipient(s) will receive a notice that he/she has a new",
"memo.  The recipient's nickname must be registered with",
"\2" ns "\2.",
NULL
};
/***********************************************************/
static const char *ms_help_purge[] = {
"Syntax: \2PURGE\2",
" ",
"Erases all memos marked as deleted.",
"Once a memo has been purged, there is",
"NO way to get it back.",
" ",
NULL
};
/***********************************************************/
static const char *ms_help_undel[] = {
"Syntax: \2UNDEL {\37num\37|\37ALL\37}",
" ",
"If the memo specified is marked as deleted,",
"the mark flag will be removed from the memo.",
"After the memo has been undeleted, the memo",
"will not be erased when you go offline or",
"use \2PURGE\2. Memos are never automatically",
"marked. If \2ALL\2 is given, all marked memos",
"as deleted will be unmarked.",
" ",
NULL
};
/*********************************************/
static const char *ms_help_unsend[] = {
"Syntax: \2UNSEND \37nick\37\2",
" ",
"Retrieves the latest memo you sent to",
"the person, and deletes it. This feature",
"currently only works for nicks, not channels.",
" ",
NULL
};
/**********************************************/
static const char *ms_help_set_index[] = {
"Syntax: \2SET \37option\37 \37parameters\37\2",
" ",
"Sets various " ms " options.  \37option\37 can be one of:",
" ",
"    NOTIFY      Changes when you will be notified about",
"                new memos",
" ",
"In order to use this command, you must first identify",
"with your password (\2/msg " ns " HELP IDENTIFY\2 for more",
"information).",
" ",
"Type \2/msg " ms " HELP SET \37option\37\2 for more information",
"on a specific option.",
" ",
NULL
};
/*******************************************/
static const char *ms_help_set_notify[] = {
"Syntax: \2SET NOTIFY {ON|LOGON|NEW|OFF}\2",
" ",
"Changes when you will be notified about new memos.",
" ",
"Available options:",
"    ON          You will be notified of memos when you log on,",
"                when you unset /AWAY and when they are sent to you.",
"    LOGON       You will only be notified of memos when you log on",
"                or when you unset /AWAY.",
"    NEW         You will only be notified of memos when they are sent to you.",
"    OFF         You will not receive any notification of memos.",
" ",
"ON is essentially LOGON and NEW combined.",
" ",
NULL
};
